﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Airbus
{
    internal class AirplaneCompareByColor : IComparer<IDrawningObject>
    {
        public int Compare(IDrawningObject? x, IDrawningObject? y)
        {
            if (x == null && y == null)
            {
                return 0;
            }
            if (x == null && y != null)
            {
                return 1;
            }
            if (x != null && y == null)
            {
                return -1;
            }
            var xAirplane = x as DrawningObjectAirplane;
            var yAirplane = y as DrawningObjectAirplane;
            if (xAirplane == null && yAirplane == null)
            {
                return 0;
            }
            if (xAirplane == null && yAirplane != null)
            {
                return 1;
            }
            if (xAirplane != null && yAirplane == null)
            {
                return -1;
            }
            string xAirplaneColor = xAirplane.GetAirplane.airplane.BodyColor.Name;
            string yAirplaneColor = yAirplane.GetAirplane.airplane.BodyColor.Name;
            if (xAirplaneColor != yAirplaneColor)
            {
                return xAirplaneColor.CompareTo(yAirplaneColor);
            }
            if (xAirplane.GetAirplane.airplane is EntityAirbus xContainerShip && yAirplane.GetAirplane.airplane is EntityAirbus yContainerShip)
            {
                string xShipDopColor = xContainerShip.DopColor.Name;
                string yShipDopColor = yContainerShip.DopColor.Name;
                var dopColorCompare = xShipDopColor.CompareTo(yShipDopColor);
                if (dopColorCompare != 0)
                {
                    return dopColorCompare;
                }
            }
            var speedCompare = xAirplane.GetAirplane.airplane.Speed.CompareTo(yAirplane.GetAirplane.airplane.Speed);
            if (speedCompare != 0)
            {
                return speedCompare;
            }
            return xAirplane.GetAirplane.airplane.Weight.CompareTo(yAirplane.GetAirplane.airplane.Weight);
        }
    }
}